Blame


1 0e673013 2019-01-02 stsp #!/bin/sh
2 0e673013 2019-01-02 stsp #
3 0e673013 2019-01-02 stsp # Copyright (c) 2019 Stefan Sperling <stsp@openbsd.org>
4 0e673013 2019-01-02 stsp #
5 0e673013 2019-01-02 stsp # Permission to use, copy, modify, and distribute this software for any
6 0e673013 2019-01-02 stsp # purpose with or without fee is hereby granted, provided that the above
7 0e673013 2019-01-02 stsp # copyright notice and this permission notice appear in all copies.
8 0e673013 2019-01-02 stsp #
9 0e673013 2019-01-02 stsp # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 0e673013 2019-01-02 stsp # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 0e673013 2019-01-02 stsp # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 0e673013 2019-01-02 stsp # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 0e673013 2019-01-02 stsp # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 0e673013 2019-01-02 stsp # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 0e673013 2019-01-02 stsp # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 0e673013 2019-01-02 stsp
17 003cc5a3 2019-08-08 stsp export GOT_AUTHOR="Flan Hacker <flan_hacker@openbsd.org>"
18 82f6abb8 2019-08-14 stsp export GOT_AUTHOR_8="flan_hac"
19 b1ebc001 2019-08-13 stsp export GOT_LOG_DEFAULT_LIMIT=0
20 c3754a5b 2019-05-10 stsp
21 7b67836a 2019-05-10 stsp export MALLOC_OPTIONS=S
22 7b67836a 2019-05-10 stsp
23 0e673013 2019-01-02 stsp function git_init
24 0e673013 2019-01-02 stsp {
25 0e673013 2019-01-02 stsp git init -q "$@"
26 0e673013 2019-01-02 stsp }
27 0e673013 2019-01-02 stsp
28 0e673013 2019-01-02 stsp function git_commit
29 0e673013 2019-01-02 stsp {
30 0e673013 2019-01-02 stsp local repo="$1"
31 0e673013 2019-01-02 stsp shift
32 0e673013 2019-01-02 stsp (cd $repo && git commit -q -a "$@")
33 0e673013 2019-01-02 stsp }
34 0e673013 2019-01-02 stsp
35 512f0d0e 2019-01-02 stsp function git_rm
36 512f0d0e 2019-01-02 stsp {
37 512f0d0e 2019-01-02 stsp local repo="$1"
38 512f0d0e 2019-01-02 stsp shift
39 512f0d0e 2019-01-02 stsp (cd $repo && git rm -q "$@")
40 512f0d0e 2019-01-02 stsp }
41 512f0d0e 2019-01-02 stsp
42 9c4b8182 2019-01-02 stsp function git_show_head
43 9c4b8182 2019-01-02 stsp {
44 9c4b8182 2019-01-02 stsp local repo="$1"
45 9c4b8182 2019-01-02 stsp (cd $repo && git show --no-patch --pretty='format:%H')
46 9c4b8182 2019-01-02 stsp }
47 9c4b8182 2019-01-02 stsp
48 bcb49d15 2019-08-14 stsp function git_show_author_time
49 bcb49d15 2019-08-14 stsp {
50 bcb49d15 2019-08-14 stsp local repo="$1"
51 bcb49d15 2019-08-14 stsp (cd $repo && git show --no-patch --pretty='format:%at')
52 bcb49d15 2019-08-14 stsp }
53 bcb49d15 2019-08-14 stsp
54 818c7501 2019-07-11 stsp function git_show_parent_commit
55 818c7501 2019-07-11 stsp {
56 818c7501 2019-07-11 stsp local repo="$1"
57 818c7501 2019-07-11 stsp (cd $repo && git show --no-patch --pretty='format:%P')
58 818c7501 2019-07-11 stsp }
59 818c7501 2019-07-11 stsp
60 03415a1a 2019-06-02 stsp function git_show_tree
61 03415a1a 2019-06-02 stsp {
62 03415a1a 2019-06-02 stsp local repo="$1"
63 03415a1a 2019-06-02 stsp (cd $repo && git show --no-patch --pretty='format:%T')
64 03415a1a 2019-06-02 stsp }
65 03415a1a 2019-06-02 stsp
66 818c7501 2019-07-11 stsp function trim_obj_id
67 818c7501 2019-07-11 stsp {
68 818c7501 2019-07-11 stsp let trimcount=$1
69 818c7501 2019-07-11 stsp id=$2
70 818c7501 2019-07-11 stsp
71 818c7501 2019-07-11 stsp pat=""
72 818c7501 2019-07-11 stsp while [ trimcount -gt 0 ]; do
73 818c7501 2019-07-11 stsp pat="[0-9a-f]$pat"
74 818c7501 2019-07-11 stsp let trimcount--
75 818c7501 2019-07-11 stsp done
76 818c7501 2019-07-11 stsp
77 818c7501 2019-07-11 stsp echo ${id%$pat}
78 818c7501 2019-07-11 stsp }
79 818c7501 2019-07-11 stsp
80 03415a1a 2019-06-02 stsp function git_commit_tree
81 03415a1a 2019-06-02 stsp {
82 03415a1a 2019-06-02 stsp local repo="$1"
83 03415a1a 2019-06-02 stsp local msg="$2"
84 03415a1a 2019-06-02 stsp local tree="$3"
85 03415a1a 2019-06-02 stsp (cd $repo && git commit-tree -m "$msg" "$tree")
86 03415a1a 2019-06-02 stsp }
87 03415a1a 2019-06-02 stsp
88 0e673013 2019-01-02 stsp function make_test_tree
89 0e673013 2019-01-02 stsp {
90 0e673013 2019-01-02 stsp repo="$1"
91 0e673013 2019-01-02 stsp
92 0e673013 2019-01-02 stsp echo alpha > $repo/alpha
93 0e673013 2019-01-02 stsp echo beta > $repo/beta
94 0e673013 2019-01-02 stsp mkdir $repo/gamma
95 0e673013 2019-01-02 stsp echo delta > $repo/gamma/delta
96 0e673013 2019-01-02 stsp mkdir $repo/epsilon
97 0e673013 2019-01-02 stsp echo zeta > $repo/epsilon/zeta
98 0e673013 2019-01-02 stsp }
99 0e673013 2019-01-02 stsp
100 3ce1b845 2019-07-15 stsp function get_blob_id
101 3ce1b845 2019-07-15 stsp {
102 3ce1b845 2019-07-15 stsp repo="$1"
103 3ce1b845 2019-07-15 stsp tree_path="$2"
104 3ce1b845 2019-07-15 stsp filename="$3"
105 3ce1b845 2019-07-15 stsp
106 3ce1b845 2019-07-15 stsp got tree -r $repo -i $tree_path | grep ${filename}$ | cut -d' ' -f 1
107 3ce1b845 2019-07-15 stsp }
108 3ce1b845 2019-07-15 stsp
109 0e673013 2019-01-02 stsp function test_init
110 0e673013 2019-01-02 stsp {
111 0e673013 2019-01-02 stsp local testname="$1"
112 4a1ddfc2 2019-01-12 stsp local no_tree="$2"
113 0e673013 2019-01-02 stsp if [ -z "$testname" ]; then
114 0e673013 2019-01-02 stsp echo "No test name provided" >&2
115 0e673013 2019-01-02 stsp return 1
116 0e673013 2019-01-02 stsp fi
117 0e673013 2019-01-02 stsp local testroot=`mktemp -p /tmp -d got-test-$testname-XXXXXXXX`
118 0e673013 2019-01-02 stsp mkdir $testroot/repo
119 0e673013 2019-01-02 stsp git_init $testroot/repo
120 4a1ddfc2 2019-01-12 stsp if [ -z "$no_tree" ]; then
121 4a1ddfc2 2019-01-12 stsp make_test_tree $testroot/repo
122 3ce1b845 2019-07-15 stsp (cd $repo && git add .)
123 4a1ddfc2 2019-01-12 stsp git_commit $testroot/repo -m "adding the test tree"
124 4a1ddfc2 2019-01-12 stsp fi
125 0e673013 2019-01-02 stsp echo "$testroot"
126 0e673013 2019-01-02 stsp }
127 0e673013 2019-01-02 stsp
128 0e673013 2019-01-02 stsp function test_cleanup
129 0e673013 2019-01-02 stsp {
130 0e673013 2019-01-02 stsp local testroot="$1"
131 fe7842f5 2019-07-14 stsp
132 fe7842f5 2019-07-14 stsp (cd $testroot/repo && git fsck --strict \
133 fe7842f5 2019-07-14 stsp > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
134 fe7842f5 2019-07-14 stsp ret="$?"
135 fe7842f5 2019-07-14 stsp if [ "$ret" != "0" ]; then
136 fe7842f5 2019-07-14 stsp echo -n "git fsck: "
137 fe7842f5 2019-07-14 stsp cat $testroot/fsck.stderr
138 fe7842f5 2019-07-14 stsp echo "git fsck failed; leaving test data in $testroot"
139 fe7842f5 2019-07-14 stsp return 1
140 fe7842f5 2019-07-14 stsp fi
141 fe7842f5 2019-07-14 stsp
142 0e673013 2019-01-02 stsp rm -rf "$testroot"
143 0e673013 2019-01-02 stsp }
144 0e673013 2019-01-02 stsp
145 0e673013 2019-01-02 stsp function run_test
146 0e673013 2019-01-02 stsp {
147 0e673013 2019-01-02 stsp testfunc="$1"
148 370629d7 2019-01-02 stsp echo -n "$testfunc "
149 0e673013 2019-01-02 stsp $testfunc
150 0e673013 2019-01-02 stsp }
151 0e673013 2019-01-02 stsp
152 0e673013 2019-01-02 stsp function test_done
153 0e673013 2019-01-02 stsp {
154 0e673013 2019-01-02 stsp local testroot="$1"
155 0e673013 2019-01-02 stsp local result="$2"
156 0e673013 2019-01-02 stsp if [ "$result" == "0" ]; then
157 fe7842f5 2019-07-14 stsp test_cleanup "$testroot" || return 1
158 370629d7 2019-01-02 stsp echo "ok"
159 3941b73a 2019-05-14 stsp elif echo "$result" | grep -q "^xfail"; then
160 3941b73a 2019-05-14 stsp # expected test failure; test reproduces an unfixed bug
161 3941b73a 2019-05-14 stsp echo "$result"
162 17201126 2019-07-14 stsp test_cleanup "$testroot" || return 1
163 0e673013 2019-01-02 stsp else
164 0e673013 2019-01-02 stsp echo "test failed; leaving test data in $testroot"
165 0e673013 2019-01-02 stsp fi
166 0e673013 2019-01-02 stsp }